/*************************************************************************
 *    CompuCell - A software framework for multimodel simulations of     *
 * biocomplexity problems Copyright (C) 2003 University of Notre Dame,   *
 *                             Indiana                                   *
 *                                                                       *
 * This program is free software; IF YOU AGREE TO CITE USE OF CompuCell  *
 *  IN ALL RELATED RESEARCH PUBLICATIONS according to the terms of the   *
 *  CompuCell GNU General Public License RIDER you can redistribute it   *
 * and/or modify it under the terms of the GNU General Public License as *
 *  published by the Free Software Foundation; either version 2 of the   *
 *         License, or (at your option) any later version.               *
 *                                                                       *
 * This program is distributed in the hope that it will be useful, but   *
 *      WITHOUT ANY WARRANTY; without even the implied warranty of       *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    *
 *             General Public License for more details.                  *
 *                                                                       *
 *  You should have received a copy of the GNU General Public License    *
 *     along with this program; if not, write to the Free Software       *
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.        *
 *************************************************************************/

#ifndef FIELDRENDERER_H
#define FIELDRENDERER_H

#include <CompuCell3D/SimObject.h>

#include "VizProperties.h"

#include <CompuCell3D/Field3D/Field3D.h>


namespace CompuCell3D {
  class CellG;
  class Simulator;
  
  class FieldRenderer : public Field3D<VizProperties>, public SimObject {
  
  protected:
    Field3D<CellG *> *cellFieldG;

  public:
    FieldRenderer() : cellFieldG(0) {}
    virtual ~FieldRenderer() {}

    void init(Simulator *simulator);

    void set(const Point3D &pt, const VizProperties value);
    Dim3D getDim() const;
    bool isValid(const Point3D &pt) const;
  };
};
#endif
