/*************************************************************************
 *    CompuCell - A software framework for multimodel simulations of     *
 * biocomplexity problems Copyright (C) 2003 University of Notre Dame,   *
 *                             Indiana                                   *
 *                                                                       *
 * This program is free software; IF YOU AGREE TO CITE USE OF CompuCell  *
 *  IN ALL RELATED RESEARCH PUBLICATIONS according to the terms of the   *
 *  CompuCell GNU General Public License RIDER you can redistribute it   *
 * and/or modify it under the terms of the GNU General Public License as *
 *  published by the Free Software Foundation; either version 2 of the   *
 *         License, or (at your option) any later version.               *
 *                                                                       *
 * This program is distributed in the hope that it will be useful, but   *
 *      WITHOUT ANY WARRANTY; without even the implied warranty of       *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    *
 *             General Public License for more details.                  *
 *                                                                       *
 *  You should have received a copy of the GNU General Public License    *
 *     along with this program; if not, write to the Free Software       *
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.        *
 *************************************************************************/

#ifndef CENTEROFMASSTYPERENDERER_H
#define CENTEROFMASSTYPERENDERER_H

#include <map>

#include <CompuCell3D/Viz/FieldRenderer.h>

namespace CompuCell3D {
  class Simulator;
  class CenterOfMassPlugin;
  class Automaton;

  class CenterOfMassTypeRenderer : public FieldRenderer {
    CenterOfMassPlugin *centerOfMassPlugin;
    Automaton* automaton;
    
    VizProperties medium;
    // VizProperties surface;
    std::map<char, VizProperties> surfaces;
    VizProperties center;
    
  public:
    CenterOfMassTypeRenderer() : centerOfMassPlugin(0), automaton(0) {}

    virtual VizProperties get(const Point3D &pt) const;

    // SimObject interface
    virtual void init(Simulator *simulator);

    // Begin XMLSerializable interface
    virtual void readXML(XMLPullParser &in);
    virtual void writeXML(XMLSerializer &out);
    // End XMLSerializable interface    
  };
};
#endif
