/*******************************************************************\

              Copyright (C) 2002, 2003 Joseph Coffland

    This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
        of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
             GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
                           02111-1307, USA.

            For information regarding this software email
                   jcofflan@users.sourceforge.net

\*******************************************************************/

#ifndef DOMHELPERS_H
#define DOMHELPERS_H

#include <string>
#include <iostream>

#include <xercesc/util/XercesDefs.hpp>

namespace XERCES_CPP_NAMESPACE {
  class DOMNode;
  class DOMException;
};

/** 
 * This function will aggregate the text of this node and its
 * children recursively.
 *
 * @return The text value of the supplied node.
 */
std::string getDOMNodeText(XERCES_CPP_NAMESPACE::DOMNode *node);

/** 
 * @return True if string == 'true', false otherwise.
 */
bool getBoolValue(const std::string str);

/** 
 * @return A text description of the supplied DOM error code.
 */
const std::string DOMErrorCode2String(int code);

/// Print a DOMException to a stream.
std::ostream &operator<<(std::ostream &stream, 
			 const XERCES_CPP_NAMESPACE::DOMException &e);

#endif // DOMHELPERS_H
