/*******************************************************************\

              Copyright (C) 2002, 2003 Joseph Coffland

    This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
        of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
             GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
                           02111-1307, USA.

            For information regarding this software email
                   jcofflan@users.sourceforge.net

\*******************************************************************/

#ifndef XMLCOMPARE_H
#define XMLCOMPARE_H

#include <xercesc/util/XercesDefs.hpp>

namespace XERCES_CPP_NAMESPACE {
  class DOMNode;
  class DOMNodeList;
};

/** 
 * Compare a list of DOMNodes.
 * 
 * @return True if the lists are equal, false otherwise.
 */
bool xmlCompareNodeList(XERCES_CPP_NAMESPACE::DOMNodeList *list1, 
			XERCES_CPP_NAMESPACE::DOMNodeList *list2,
			unsigned int index1 = 0, unsigned int index2 = 0);

/** 
 * Compare two DOMNodes.
 * 
 * @return True if the lists are equal, false otherwise.
 */
bool xmlCompare(XERCES_CPP_NAMESPACE::DOMNode *node1,
		XERCES_CPP_NAMESPACE::DOMNode *node2);
#endif // XMLCOMPARE_H
