#ifndef UNIVERSALGRAPHICSSETTINGS_H
#define UNIVERSALGRAPHICSSETTINGS_H
#include <map>
#include <vector>
#include <qcolor.h>
#include <qpen.h>
#include <qbrush.h>

class UniversalGraphicsSettings{
   public:
      typedef std::map<unsigned short,QColor>::iterator colorMapItr;
      typedef std::map<unsigned short,QColor> colorMap_t;
      bool bordersOn;
      bool contoursOn;
      bool concentrationLimitsOn;
      int zoomFactor;
      std::map<unsigned short,QColor> typeColorMap;
      QColor defaultColor;
      QColor borderColor;
      QColor contourColor;
      std::vector<unsigned short> types3DInvisibleVec;
      //colormaps
      std::map<unsigned short,QPen> typePenMap;
      std::map<unsigned short,QBrush> typeBrushMap;
      QBrush defaultBrush;
      QPen defaultPen;
      QPen borderPen;
      QPen contourPen;
      bool avoidType(unsigned short type);

      
};

#endif
