/*******************************************************************\

              Copyright (C) 2003 Joseph Coffland

    This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
        of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
             GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
                           02111-1307, USA.

            For information regarding this software email
                   jcofflan@users.sourceforge.net

\*******************************************************************/

#ifndef ARRAYFORMATTARGET_H
#define ARRAYFORMATTARGET_H

#include <xercesc/util/XercesDefs.hpp>
#include <xercesc/framework/XMLFormatter.hpp>

#include <BasicUtils/BasicArray.h>

namespace XERCES_CPP_NAMESPACE {
  class XMLFormatter;
};


#include <iostream>

/** 
 * A Xerces C++ XMLFormatTarget for BasicArray<char>
 */
class ArrayFormatTarget : public XERCES_CPP_NAMESPACE::XMLFormatTarget,
			  public BasicArray<char> {
 public:
  // Begin XMLFormatTarget interface
  void writeChars(const XMLByte *const toWrite, 
		  const unsigned int count, 
		  XERCES_CPP_NAMESPACE::XMLFormatter *const formatter) {
    
    put((char *)toWrite, count);
  }

  void flush() {}
  // End XMLFormatTarget interface
};

#endif // ARRAYFORMATTARGET_H
