/*******************************************************************\

              Copyright (C) 2003 Joseph Coffland

    This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
        of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
             GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
                           02111-1307, USA.

            For information regarding this software email
                   jcofflan@users.sourceforge.net

\*******************************************************************/

#ifndef XMLATTRIB_H
#define XMLATTRIB_H

#include <string>

/**
 * All information about an XML element attribute.
 */
struct XMLAttrib {
  /// The attribute name.
  std::string name;

  /// The attribute value.
  std::string value;

  /// The attribute type string.
  std::string type;

  /// The Uniform Resource Identifier or namespace
  std::string uri;

  /// The attribute prefix.
  std::string prefix;

  XMLAttrib(const std::string name, const std::string value,
	    const std::string type = "", const std::string uri = "",
	    const std::string prefix = "") : 
    name(name), value(value), type(type), uri(uri), prefix(prefix) {}

  XMLAttrib() {}
};
#endif
