/*******************************************************************\

              Copyright (C) 2003 Joseph Coffland

    This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
        of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
             GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
                           02111-1307, USA.

            For information regarding this software email
                   jcofflan@users.sourceforge.net

\*******************************************************************/

#include <XMLCereal/XMLPullParserImpl.h>
#include <BasicUtils/BasicException.h>

#include <iostream>
#include <fstream>
using namespace std;

int testMain(int argc, char *argv[]) {
  ASSERT_OR_THROW("Invaid arguments to test!", argc > 1);

  ifstream in1(argv[1]);

  XMLPullParserImpl parser;
  parser.initParse(in1);

  parser.match(XMLPullParser::START_DOCUMENT);
  parser.match(XMLPullParser::START_ELEMENT);
  cout << "Found element start." << endl;
 
  cout << "depth=" << parser.getDepth() << endl;

  in1.close();
  ifstream in2(argv[1]);
  parser.initParse(in2);
  cout << "Changed parser input." << endl;

  cout << "depth=" << parser.getDepth() << endl;

  parser.match(XMLPullParser::START_DOCUMENT);
  parser.match(XMLPullParser::START_ELEMENT);
  cout << "Found element start." << endl;
  parser.match(XMLPullParser::END_ELEMENT);
  cout << "Found element end." << endl;
  parser.match(XMLPullParser::END_DOCUMENT);

  return 0;
}
