/*******************************************************************\

              Copyright (C) 2003 Joseph Coffland

    This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
        of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
             GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
                           02111-1307, USA.

            For information regarding this software email
                   jcofflan@users.sourceforge.net

\*******************************************************************/

#include <XMLCereal/XMLPullParserImpl.h>
#include <XercesUtils/XercesStr.h>

#include <xercesc/util/XMLString.hpp>

#include <iostream>
using namespace std;
XERCES_CPP_NAMESPACE_USE;

const string slProperty = 
"http://apache.org/xml/properties/schema/external-schemaLocation";

int testMain(int argc, char *argv[]) {
  XMLPullParserImpl parser;

  XMLCh *data = XMLString::transcode("test_value");
  parser.setProperty(slProperty, data);
  XMLString::release(&data);

  data = (XMLCh *)parser.getProperty(slProperty);

  cout << slProperty << "='" << XercesStr(data) << "'" << endl;

  return 0;
}
